#ifndef __IDX_H
#define __IDX_H

#define UNIFORM_PLUS_MINUS_ONE ( (double)(2.0 * rand())/RAND_MAX - 1.0 )
#define UNIFORM_ZERO_ONE ((double)(rand()/RAND_MAX))

const int MAX_CLASSES=10;

typedef struct{
	int		cls;
	double	val;
}Result;

typedef struct{
	int		idx;
	Result	outputs[MAX_CLASSES];	//the highest MAX_CLASSES scores together with their classes, in a descending order
	double	scores[MAX_CLASSES];		//just for building the CPU code
}Error;

int random(int limit);
int myround(double x);
int myroundf(float x);

class IDXHandler {
private:

protected:
	int					*labels;
	int					*indexes;
	static const int	batch=100;				// batch size

public:
	char				filename[1000];
	unsigned char		*buffer;					//bufers for input images
	
	double				*bufferDoubles;
	int					bufferSize;					// everything will be buffer_size elements
	int					width, height;
	int					n_labels;					//number of different labels
	int					label_map[10000];			//the map that translates labels (max 10000 labels) 
	int					samplesPerClass[10000];		// max 10000 classes
	int					nImages;					//number of images/labels
	unsigned			signature,datatype,dimmensions,samplesize;
	bool				reverted;
	__int64				headersize;
	
	IDXHandler(int _bufferSize=1000);
	~IDXHandler();
	void loadIDXimages(const char *filename);
	void loadIDXlabels(const char *filename);
	void saveIDXimages(const char *filename);
	void saveImages(char *filename);
	void saveErrorImages(char *filename, Error *errorvector, int size);
	void unloadIDX();
	int getLabel(int  index);
	void scramble();
	double *getImageAsDoubles(int index);
	void allocateBuffer(void);
	void collectData(int startIdx);
	void saveBatchAsIDX(char *filename);

protected:
	void reverse(unsigned  &sig);
	void switchidx(int i1, int i2);
};

#endif
